/**
 * \file
 *
 * \brief Empty user application template
 *
 */

/*
 * Include header files for all drivers that have been imported from
 * Atmel Software Framework (ASF).
 */

#include <asf.h>
#include <mytasks.h>


void vApplicationIdleHook(void);
void vApplicationIdleHook(void);
void vReset(void);



#define mainLED_TASK_PRIORITY (tskIDLE_PRIORITY+1)
#define secondLED_TASK_PRIORITY (tskIDLE_PRIORITY+1)
#define USB_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define ADC_TASK_PRIORITY (tskIDLE_PRIORITY+1)
#define USART_GSM_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define USART_SENSOR_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define BUTTON_CHECK_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define RESET_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define SPI_FLASH_TASK_PRIORITY (tskIDLE_PRIORITY+2)
#define MOTOR_CONTROL_TASK_PRIORITY (tskIDLE_PRIORITY+2)

int main (void)
{
	
	sleepmgr_init();
	sysclk_init();
	board_init();
	//INC initialization
	INTC_init_interrupts();
	//stdio_usb_init(&AVR32_USART1);
	
	
	
	
	xTaskCreate(vUsbSendDataTask,(signed char *) "USB_DATA_SEND", configMINIMAL_STACK_SIZE, NULL,USB_TASK_PRIORITY,NULL);
	xTaskCreate(vUsartGsmTask,(signed char *)"USART_GSM_TASK",configMINIMAL_STACK_SIZE,NULL,USART_GSM_TASK_PRIORITY,NULL);
    xTaskCreate(vUsartSensorTask,(signed char *)"USART_SENSOR_TASK",configMINIMAL_STACK_SIZE,NULL,USART_SENSOR_TASK_PRIORITY,NULL);
	xTaskCreate(vButtonPollTask,(signed char *)"BUTTON_STATUS_TASK",configMINIMAL_STACK_SIZE,NULL,BUTTON_CHECK_TASK_PRIORITY,NULL);
    xTaskCreate(vReset,(signed char *)"SOFT_RESET_TASK",configMINIMAL_STACK_SIZE,NULL,RESET_TASK_PRIORITY,NULL);
	xTaskCreate(vSpiDataFlashTask,(signed char *) "SPI_FLASH_TASK",configMINIMAL_STACK_SIZE,NULL,SPI_FLASH_TASK_PRIORITY,NULL);
	//xTaskCreate(vMotorControlTask,(signed char *) "MOTOR_CONTROL_TASK",configMINIMAL_STACK_SIZE,NULL,MOTOR_CONTROL_TASK_PRIORITY,NULL);
	
	vTaskStartScheduler();
	
	while(1){}
		
     return 0;
	
}
void vApplicationTickHook(void)
{
	 
	LED_Toggle(LED3);
	
}
	
void vApplicationIdleHook(void)
{
 // sleepmgr_enter_sleep();
SLEEP(0);
}

