    /*
 * mytasks.c
 *
 * Created: 10/9/2012 6:22:41 PM
 *  Author: Alireza
 */ 
//*******Libraries header files***********************
#include <asf.h>
#include <mytasks.h>
#include <math.h>
#include <stdio.h>
//********************************************
#include "conf_at45dbx.h"
/*! \name AT45DBX Group C Commands
 */
//! @{
//! Status Register Read (Serial/8-bit Mode).
#define AT45DBX_CMDC_RD_STATUS_REG        0xD7
//! @}

/*! \name Bit-Masks and Values for the Status Register
 */
//! @{
#define AT45DBX_MSK_DENSITY               0x0C      //!< Device density bit-mask
#define AT45DBX_DENSITY                   0x0C      //!< Device density value.
//! @}
#define AT45DBX_SPI             (&AVR32_SPI0)
#define SPI_example_ID    AT45DBX_SPI_NPCS

//***************************************************
// GPIO configuration
static const gpio_map_t COMPORT_3_GPIO_MAP =
{
{AVR32_USART3_RXD_0_2_PIN ,  AVR32_USART3_RXD_0_2_FUNCTION},
{ AVR32_USART3_TXD_0_3_PIN, AVR32_USART3_TXD_0_3_FUNCTION}
};

//USART Configuration
static const usart_options_t usart_options = {
	//! Set baud rate of the USART (unused in slave modes).
	.baudrate= 9600,
	

	//! Number of bits to transmit as a character (5 to 9).
	.charlength = 8,

	//! How to calculate the parity bit: \ref USART_EVEN_PARITY, \ref USART_ODD_PARITY,
	//! \ref USART_SPACE_PARITY, \ref USART_MARK_PARITY, \ref USART_NO_PARITY or
	//! \ref USART_MULTIDROP_PARITY.
	.paritytype = USART_NO_PARITY,

	//! Number of stop bits between two characters: \ref USART_1_STOPBIT,
	//! \ref USART_1_5_STOPBITS, \ref USART_2_STOPBITS or any number from 3 to 257
	//! which will result in a time guard period of that length between characters.
	//! \note \ref USART_1_5_STOPBITS is supported in asynchronous modes only.
	.stopbits= USART_1_STOPBIT,

	//! Run the channel in testmode: \ref USART_NORMAL_CHMODE, \ref USART_AUTO_ECHO,
	//! \ref USART_LOCAL_LOOPBACK or \ref USART_REMOTE_LOOPBACK.
	.channelmode = USART_NORMAL_CHMODE,
};

// watch dog reset timeout
#define WDT_VALUE   1000000 // 1 second for reset
wdt_opt_t opt = {
	.us_timeout_period = WDT_VALUE
};


// SPI options and initialization functions
static spi_options_t spiOptions =
{
	.reg          =AT45DBX_SPI_FIRST_NPCS,
	.baudrate     = AT45DBX_SPI_MASTER_SPEED,
	.bits         = AT45DBX_SPI_BITS,
	.spck_delay   = 0,
	.trans_delay  = 0,
	.stay_act     = 1,
	.spi_mode     = 0,
	.modfdis      = 1
};

struct spi_device spi_device_conf = {
	.id = SPI_example_ID
};

static void spi_init_module(void)
{
	static const gpio_map_t AT45DBX_SPI_GPIO_MAP =
	{
	{AT45DBX_SPI_SCK_PIN,          AT45DBX_SPI_SCK_FUNCTION         },  // SPI Clock.
	{AT45DBX_SPI_MISO_PIN,         AT45DBX_SPI_MISO_FUNCTION        },  // MISO.
	{AT45DBX_SPI_MOSI_PIN,         AT45DBX_SPI_MOSI_FUNCTION        },  // MOSI.
		#define AT45DBX_ENABLE_NPCS_PIN(NPCS, unused) \
	{AT45DBX_SPI_NPCS##NPCS##_PIN, AT45DBX_SPI_NPCS##NPCS##_FUNCTION},  // Chip Select NPCS.
		MREPEAT(AT45DBX_MEM_CNT, AT45DBX_ENABLE_NPCS_PIN, ~)
		#undef AT45DBX_ENABLE_NPCS_PIN
	};
	// Assign I/Os to SPI.
	gpio_enable_module(AT45DBX_SPI_GPIO_MAP,
	sizeof(AT45DBX_SPI_GPIO_MAP) / sizeof(AT45DBX_SPI_GPIO_MAP[0]));
	//Init SPI module as master
	// spi_master_init(SPI_EXAMPLE);
	spi_initMaster(AT45DBX_SPI, &spiOptions);
	
	//Setup parameters for the slave device
	// spi_master_setup_device(SPI_EXAMPLE, &spi_device_conf, SPI_MODE_0,12000000, 0);
	spi_initMaster(AT45DBX_SPI, &spiOptions);
	
	//Allow the module to transfer data
	spi_enable(AT45DBX_SPI);
	// Initialize data flash with SPI clock Osc0.
	at45dbx_init(spiOptions, 12000000);
}

//*******************variables and queues*************************************
xQueueHandle xADCQueue; 
xSemaphoreHandle xReadSensorSemaphore=NULL;
xSemaphoreHandle xSpiSemaphore=NULL;
xSemaphoreHandle xButtonSemaphore=NULL;
xSemaphoreHandle xSendDataSemaphore=NULL;
 volatile u8 comm_buf[10];
volatile uint8_t SENSOR_DATA[120];
volatile u8 data_flash_buf[120];
 char usb_buf[20];
 
//*************** Interrupt service routines********************************** 
 // USART3 Interrupt service routine
 __attribute__((__interrupt__))
 static void usart3_isr(void)
 {
	static portBASE_TYPE xTaskWoken_SENSOR = pdFALSE;
	static uint8_t i=0;
	
	(&AVR32_USART3)->cr|= (1 << AVR32_USART_CR_RSTSTA_OFFSET);
	SENSOR_DATA[i]=((&AVR32_USART3)->rhr & AVR32_USART_RHR_RXCHR_MASK) >> AVR32_USART_RHR_RXCHR_OFFSET;	
	
	i++;
	if(i>119)
	{
	i=0;
	if(xReadSensorSemaphore != NULL)
		xTaskWoken_SENSOR= xSemaphoreGiveFromISR(xReadSensorSemaphore,xTaskWoken_SENSOR);
	}	
 }
	  
 // USART1 Interrupt service routine
 __attribute__((__interrupt__))
 static void usart1_isr(void)
 {
	 static uint8_t j=0;
	 static portBASE_TYPE xTaskWoken_GSM = pdFALSE;
	 
	 (&AVR32_USART1)->cr|= (1 << AVR32_USART_CR_RSTSTA_OFFSET);
	comm_buf[j]=((&AVR32_USART1)->rhr & AVR32_USART_RHR_RXCHR_MASK) >> AVR32_USART_RHR_RXCHR_OFFSET;
	j++;
	if(j>9)
	{
		j=0;
		if (&comm_buf=="SEND_DATA\n")
		  if(xSendDataSemaphore != NULL)
			  xTaskWoken_GSM= xSemaphoreGiveFromISR(xSendDataSemaphore,xTaskWoken_GSM);
	}
	
 }	 
 
//*********************Tasks******************************** 
 
void vLEDFlashTask0( void *pvparameteres )
{
	
	
//	board_init();
     portTickType xLastWakeTime;
	const portTickType xFrequency=10;
	xLastWakeTime=xTaskGetTickCount();
	
	for(;;)
	{
		LED_Toggle(LED0);
		vTaskDelayUntil(&xLastWakeTime,xFrequency);
		}
}		
	
void vLEDFlashTask1(void *pvparameteres){
	//board_init();
	portTickType xLastWakeTime;
	xLastWakeTime=xTaskGetTickCount();
	for(;;){
		
		LED_Toggle(LED1);
		vTaskDelayUntil(&xLastWakeTime,10);
		
		}
	
}

void vUsbSendDataTask(void *pvparameters){
	
		sysclk_enable_peripheral_clock(&AVR32_USART1);
		usart_init_rs232(&AVR32_USART1,&usart_options,FOSC0);
    
		portTickType xLastWakeTime;
		xLastWakeTime = xTaskGetTickCount();
		taskENTER_CRITICAL();
		{
		 stdio_usb_init(&AVR32_USART1);
		}		 
		taskEXIT_CRITICAL();
    
	while(1){
	  vTaskDelayUntil(&xLastWakeTime, 100);
		if(xButtonSemaphore!=NULL)
			if(xSemaphoreTake(xButtonSemaphore,(portTickType)0))
				for(int j=0;j<120;j++)
				{
					udi_cdc_putc(data_flash_buf[j]);
					 vTaskDelayUntil(&xLastWakeTime, 50);
				}				
	}
}

void vADCTask(void *pvparameteres)
{
	volatile uint8_t data;
	
	portTickType xLastWakeTime;
	xLastWakeTime = xTaskGetTickCount();
	
	sysclk_enable_peripheral_clock(&AVR32_ADC);
	adc_configure(&AVR32_ADC);
	(&AVR32_ADC)->mr |= (1<<AVR32_ADC_LOWRES_OFFSET);
	adc_enable(&AVR32_ADC,AVR32_ADC_CH3);
	//xADCQueue=xQueueCreate(10,1); 
	
	while(1){
		adc_start(&AVR32_ADC);
		vTaskDelayUntil(&xLastWakeTime,100);
		if(adc_check_eoc(&AVR32_ADC,AVR32_ADC_CH3))
		{
		   data=adc_get_value(&AVR32_ADC,AVR32_ADC_CH3_OFFSET);
		// if(xADCQueue != 0)
		 //{
		//	 xQueueSend(xADCQueue,(void *) &data, (portTickType) 0);
			LED_Toggle(LED2);
	//	}
		}		
		
		}		
	}
	
void vUsartGsmTask(void *pvparameteres)
	{
	   vSemaphoreCreateBinary(xSendDataSemaphore);
	   xSemaphoreTake(xSendDataSemaphore,0);
        
		
		sysclk_enable_peripheral_clock(&AVR32_USART1);
		usart_init_rs232(&AVR32_USART1,&usart_options,FOSC0);
		INTC_register_interrupt((__int_handler)&usart1_isr,AVR32_USART1_IRQ,AVR32_INTC_INT0);
		(&AVR32_USART1) -> ier = (1<< AVR32_USART_RXRDY_OFFSET);
		
		
		portTickType xLastWakeTime;
		xLastWakeTime= xTaskGetTickCount();
	             
		
    while(1){
			     
        if(xSpiSemaphore != NULL)
            {
                if (xSemaphoreTake(xSpiSemaphore, (portTickType)20)==pdTRUE)	
                        {
				 usart_write_line(&AVR32_USART1,"ATE0\r\n");
			    vTaskDelayUntil(&xLastWakeTime,20);
				 usart_write_line(&AVR32_USART1,"AT+CPIN=6588\r\n");
				vTaskDelayUntil(&xLastWakeTime,20);
				 usart_write_line(&AVR32_USART1,"AT+CMGF=1\r\n");
				vTaskDelayUntil(&xLastWakeTime,20);
				 usart_write_line(&AVR32_USART1,"AT+CNMI=2,1\r\n");
				 vTaskDelayUntil(&xLastWakeTime,20);
				 usart_write_line(&AVR32_USART1,"AT+CMGS=+4745174817\r\n");	
				 vTaskDelayUntil(&xLastWakeTime,20);
				 usart_write_line(&AVR32_USART1,SENSOR_DATA);
			       vTaskDelayUntil(&xLastWakeTime,200);
				 usart_write_line(&AVR32_USART1,"\x1A");
			       vTaskDelayUntil(&xLastWakeTime,20);
				
                        }
            }
        vTaskDelayUntil(&xLastWakeTime,20);
					}		
						}
		
void vUsartSensorTask(void *pvparameteres)
{
	vSemaphoreCreateBinary(xReadSensorSemaphore);
	xSemaphoreTake(xReadSensorSemaphore,0);
	
	gpio_enable_module(COMPORT_3_GPIO_MAP,
	sizeof(COMPORT_3_GPIO_MAP) / sizeof(COMPORT_3_GPIO_MAP[3]));
	sysclk_enable_peripheral_clock(&AVR32_USART3);
    usart_init_rs232(&AVR32_USART3,&usart_options,FOSC0);
	INTC_register_interrupt((__int_handler)&usart3_isr,AVR32_USART3_IRQ,AVR32_INTC_INT0);
	(&AVR32_USART3) -> ier = (1<< AVR32_USART_RXRDY_OFFSET);
    
	portTickType xLastWakeTime;
	xLastWakeTime= xTaskGetTickCount();
	while(1)
	{
	  if(xSendDataSemaphore!= NULL)
	{
		if (xSemaphoreTake(xSendDataSemaphore, (portTickType)0)==pdTRUE)	
		 usart_write_line(&AVR32_USART3,"READ\r\n");
		
	}
	vTaskDelayUntil(&xLastWakeTime,100);
	}	
	
}

void vButtonPollTask(void *pvparameteres)
{
	vSemaphoreCreateBinary(xButtonSemaphore);
	xSemaphoreTake(xButtonSemaphore,0);
    
	portTickType xLastWakeTime;
	xLastWakeTime= xTaskGetTickCount();
	uint8_t Button_Status;
	
	while(1)
	{
	vTaskDelayUntil(&xLastWakeTime,10);
	Button_Status=gpio_get_pin_value(GPIO_PUSH_BUTTON_0);
	if(Button_Status==0)
	 {
			
		for (u8 k=0; k<120 ; k++)
			{
				// Perform read access.
				if(at45dbx_mem_check())
				{
					if (at45dbx_read_open(k))
					{
						data_flash_buf[k] = at45dbx_read_byte();
						
					    at45dbx_read_close();
					}
				}	
				vTaskDelayUntil(&xLastWakeTime,30);	
						
			}
		
			 if(xButtonSemaphore != NULL)
			 xSemaphoreGive(xButtonSemaphore);
			
		}
		
			
	}
		
} 

void vSpiDataFlashTask( void *pvparameteres)
{
	vSemaphoreCreateBinary(xSpiSemaphore);
	xSemaphoreTake(xSpiSemaphore,0);
    
	sysclk_enable_peripheral_clock(&AVR32_SPI0);
	// initialize the spi module and AT45DBX dataflash
	spi_init_module();
	spi_select_device(AT45DBX_SPI,&spi_device_conf);
    
	portTickType xLastWakeTime;
	xLastWakeTime= xTaskGetTickCount();
	while (1)
	{
		vTaskDelayUntil(xLastWakeTime,200);
		if(xReadSensorSemaphore != NULL)
		{
			if (xSemaphoreTake(xReadSensorSemaphore, (portTickType)0)==pdTRUE)
			{
				for (int i=0; i<120 ; i++)
				{
					//Pattern =(uint8_t)NTC_f(&result);
					if(at45dbx_mem_check())
					{
						// Perform write access.
						if (at45dbx_write_open(i))
						{
							at45dbx_write_byte(SENSOR_DATA[i]);
							// at45dbx_write_close();
							spi_deselect_device(AT45DBX_SPI,&spi_device_conf);
							LED_Toggle(LED2);
							vTaskDelayUntil(xLastWakeTime,30);
						}

					}
				}
				if(xSpiSemaphore!=NULL)
				xSemaphoreGive(xSpiSemaphore);
			}		
		}
	}	
}				
	
void vMotorControlTask( void *parameteres)
{
	
}	

	

void vReset(void) {
	wdt_enable(&opt);
	while(1){
		vTaskDelay(1000);
		wdt_disable(); 
	}
	
}


